diff --git a/gcc/m2/gm2-compiler/PCBuild.bnf b/gcc/m2/gm2-compiler/PCBuild.bnf
index 0e45b2e889c..6e263b01629 100644
--- a/gcc/m2/gm2-compiler/PCBuild.bnf
+++ b/gcc/m2/gm2-compiler/PCBuild.bnf
@@ -61,7 +61,8 @@ FROM M2Reserved IMPORT tokToTok, toktype,
                        OrTok, TimesTok, DivTok, DivideTok, ModTok, RemTok,
                        AndTok, AmbersandTok, PeriodPeriodTok, ByTok ;
 
-FROM M2Quads IMPORT Top, PushT, PopT, PushTF, PopTF, PopNothing, OperandT, PushTFA,
+FROM M2Quads IMPORT Top, PushT, PopT, PushTF, PopTF, PopNothing, OperandT, OperandTok,
+                    PushTFA,
                     PushTFn, PopTFn, PushTFtok, PopTtok, PopTFtok, PushTtok, PushTFntok,
                     PushT, PushTF, IsAutoPushOn, PushAutoOff, PushAutoOn, PopAuto,
                     BuildTypeForConstructor, BuildConstructor, BuildConstructorEnd,
@@ -120,6 +121,11 @@ FROM SymbolTable IMPORT MakeGnuAsm, PutGnuAsmVolatile, PutGnuAsm, PutGnuAsmInput
 
 FROM M2Batch IMPORT IsModuleKnown ;
 
+FROM M2StateCheck IMPORT StateCheck,
+                         InitState, PushState, PopState, InclConst, ExclConst,
+                         InclConstructor, ExclConstructor,
+                         InclConstFunc, CheckQualident ;
+
 IMPORT M2Error ;
 
 
@@ -128,9 +134,8 @@ CONST
    Pass1     = FALSE ;
 
 VAR
-   InConstParameter,
-   InConstBlock,
-   seenError       : BOOLEAN ;
+   BlockState: StateCheck ;
+   seenError : BOOLEAN ;
 
 
 PROCEDURE ErrorString (s: String) ;
@@ -407,8 +412,7 @@ END Real ;
 
 % module PCBuild end
 BEGIN
-   InConstParameter := FALSE ;
-   InConstBlock := FALSE
+   BlockState := InitState ()
 END PCBuild.
 % rules
 error       'ErrorArray' 'ErrorString'
@@ -597,7 +601,7 @@ Qualident :=                                                               % VAR
            =:
 
 ConstantDeclaration :=                                                     % VAR top: CARDINAL ; %
-                                                                           % InConstBlock := TRUE %
+                                                                           % InclConst (BlockState) %
                                                                            % top := Top() %
                                                                            % PushAutoOn %
                        ( Ident "="                                         % StartDesConst %
@@ -607,7 +611,7 @@ ConstantDeclaration :=                                                     % VAR
                                                                            % EndDesConst %
                                                                            % PopAuto %
                                                                            % Assert(top=Top()) %
-                                                                           % InConstBlock := FALSE %
+                                                                           % ExclConst (BlockState) %
                      =:
 
 ConstExpression :=                                                         % VAR top: CARDINAL ; %
@@ -697,11 +701,14 @@ ComponentValue := ComponentElement [ 'BY' ConstExpression ] =:
 ArraySetRecordValue := ComponentValue { ','                                % NextConstructorField %
                                             ComponentValue } =:
 
-Constructor := '{'                                                         % PushConstructorCastType %
+Constructor := '{'                                                         % InclConstructor (BlockState) %
+                                                                           % CheckQualident (OperandTok (1), BlockState, OperandT (1)) %
+                                                                           % PushConstructorCastType %
                                                                            % PushInConstructor %
                                                                            % BuildConstructor (GetTokenNo ()-1) %
                   [ ArraySetRecordValue ]                                  % PopConstructor %
                '}'                                                         % PopInConstructor %
+                                                                           % ExclConstructor (BlockState) %
                    =:
 
 ConstructorOrConstActualParameters := Constructor | ConstActualParameters  % PushConstFunctionType %
@@ -714,23 +721,21 @@ ConstSetOrQualidentOrFunction :=                                           % Pus
                                                                            % VAR tokpos: CARDINAL ; %
                                                                            % tokpos := GetTokenNo () %
                                  (
-                                   PushQualident                           % IF (NOT InConstParameter) AND InConstBlock
-                                                                             THEN
-                                                                                CheckNotVar (tokpos)
-                                                                             END %
-                                   ( ConstructorOrConstActualParameters |  % PushConstType %
+                                   PushQualident
+                                   ( ConstructorOrConstActualParameters |  % CheckQualident (OperandTok (1), BlockState, OperandT (1)) %
+                                                                           % PushConstType %
                                                                            % PopNothing %
                                                                           )
                                    |                                       % BuildTypeForConstructor (tokpos) %
                                      Constructor )                         % PopAuto %
                                =:
 
-ConstActualParameters :=                                                   % VAR oldConstParameter: BOOLEAN ; %
-                                                                           % oldConstParameter := InConstParameter %
-                                                                           % InConstParameter := TRUE %
+ConstActualParameters :=                                                   % PushState (BlockState) %
+                                                                           % InclConstFunc (BlockState) %
+                                                                           % CheckQualident (OperandTok (1), BlockState, OperandT (1)) %
                                                                            % PushT(0) %
                          "(" [ ConstExpList ] ")"
-                                                                           % InConstParameter := oldConstParameter %
+                                                                           % PopState (BlockState) %
                          =:
 
 ConstExpList :=                                                            % VAR n: CARDINAL ; %
@@ -1023,9 +1028,9 @@ ConstructorOrSimpleDes := Constructor |                                    % Pop
                                           SimpleDes [ ActualParameters ]
                         =:
 
-SetOrDesignatorOrFunction :=                                              % PushAutoOff %
-                                                                          % VAR tokpos: CARDINAL ; %
+SetOrDesignatorOrFunction :=                                              % VAR tokpos: CARDINAL ; %
                                                                           % tokpos := GetTokenNo () %
+                                                                          % PushAutoOff %
                              (
                                PushQualident
                                ( ConstructorOrSimpleDes |                 % PopNothing %
diff --git a/gcc/m2/gm2-gcc/init.cc b/gcc/m2/gm2-gcc/init.cc
index 17ca9189f10..de9fb997070 100644
--- a/gcc/m2/gm2-gcc/init.cc
+++ b/gcc/m2/gm2-gcc/init.cc
@@ -105,6 +105,8 @@ EXTERN void _M2_ldtoa_init (int argc, char *argv[], char *envp[]);
 EXTERN void _M2_M2Check_init (int argc, char *argv[], char *envp[]);
 EXTERN void _M2_M2SSA_init (int argc, char *argv[], char *envp[]);
 EXTERN void _M2_M2SymInit_init (int argc, char *argv[], char *envp[]);
+EXTERN void _M2_M2StateCheck_init (int argc, char *argv[], char *envp[]);
+EXTERN void _M2_P3Build_init (int argc, char *argv[], char *envp[]);
 EXTERN void exit (int);
 EXTERN void M2Comp_compile (const char *filename);
 EXTERN void RTExceptions_DefaultErrorCatch (void);
@@ -200,5 +202,7 @@ init_PerCompilationInit (const char *filename)
   _M2_M2SymInit_init (0, NULL, NULL);
   _M2_M2Check_init (0, NULL, NULL);
   _M2_M2LangDump_init (0, NULL, NULL);
+  _M2_M2StateCheck_init (0, NULL, NULL);
+  _M2_P3Build_init (0, NULL, NULL);
   M2Comp_compile (filename);
 }
diff --git a/gcc/testsuite/gm2/errors/fail/array1.mod b/gcc/testsuite/gm2/errors/fail/array1.mod
index 274011be953..221b32ed7be 100644
--- a/gcc/testsuite/gm2/errors/fail/array1.mod
+++ b/gcc/testsuite/gm2/errors/fail/array1.mod
@@ -17,9 +17,14 @@ Foundation, 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301, USA. *)
 
 MODULE array1 ;
 
+PROCEDURE init ;
 VAR
    a: ARRAY [FALSE..TRUE] OF CARDINAL ;
    i, j: CARDINAL ;
 BEGIN
    a[i=j] := j
+END init ;
+
+BEGIN
+   init
 END array1.
diff --git a/gcc/testsuite/gm2/errors/fail/badtype.mod b/gcc/testsuite/gm2/errors/fail/badtype.mod
new file mode 100644
index 00000000000..32ac3a6447c
--- /dev/null
+++ b/gcc/testsuite/gm2/errors/fail/badtype.mod
@@ -0,0 +1,10 @@
+MODULE badtype ;
+
+PROCEDURE bar (VAR a: CARDINAL) ;
+TYPE
+   Foo = a ;
+BEGIN
+END bar ;
+
+BEGIN
+END badtype.
diff --git a/gcc/testsuite/gm2/errors/fail/badvar.mod b/gcc/testsuite/gm2/errors/fail/badvar.mod
new file mode 100644
index 00000000000..2d67cb60d0b
--- /dev/null
+++ b/gcc/testsuite/gm2/errors/fail/badvar.mod
@@ -0,0 +1,10 @@
+MODULE badvar ;
+
+PROCEDURE bar (VAR a: CARDINAL) ;
+VAR
+   Foo: a ;
+BEGIN
+END bar ;
+
+BEGIN
+END badvar.
diff --git a/gcc/testsuite/gm2/errors/fail/errors-fail.exp b/gcc/testsuite/gm2/errors/fail/errors-fail.exp
index 8af0e729997..a8fbd2c177d 100644
--- a/gcc/testsuite/gm2/errors/fail/errors-fail.exp
+++ b/gcc/testsuite/gm2/errors/fail/errors-fail.exp
@@ -25,7 +25,7 @@ if $tracelevel then {
 # load support procs
 load_lib gm2-torture.exp
 
-gm2_init_pim "${srcdir}/gm2/errors/fail" -Wpedantic -Wstudents -Wunused-variable
+gm2_init_iso "${srcdir}/gm2/errors/fail" -Wpedantic -Wunused-variable -Wuninit-variable-checking=all
 
 foreach testcase [lsort [glob -nocomplain $srcdir/$subdir/*.mod]] {
     # If we're only testing specific files and this isn't one of them, skip it.
diff --git a/gcc/testsuite/gm2/errors/fail/testfio.mod b/gcc/testsuite/gm2/errors/fail/testfio.mod
index fabf93ecb95..f11e09eeac1 100644
--- a/gcc/testsuite/gm2/errors/fail/testfio.mod
+++ b/gcc/testsuite/gm2/errors/fail/testfio.mod
@@ -22,12 +22,16 @@ FROM StdIO IMPORT Write ;
 FROM StrIO IMPORT WriteString, WriteLn ;
 FROM FIO IMPORT Exists, OpenToRead, Close, File, IsNoError, EOF, ReadChar ;
 
+PROCEDURE init ;
 VAR
    i: INTEGER ;
    f: File ;
    c: CARDINAL ;
    a: ARRAY [0..20] OF CHAR ;
 BEGIN
+   IF f = 0
+   THEN
+   END ;
    WriteString('testfio starting') ; WriteLn ;
    c := 1 ;
    WHILE GetArg(a, c) DO
@@ -45,4 +49,8 @@ BEGIN
       END ;
       INC(c)
    END
+END init ;
+
+BEGIN
+   init
 END testfio.
diff --git a/gcc/testsuite/gm2/errors/fail/testparam.mod b/gcc/testsuite/gm2/errors/fail/testparam.mod
index 238334f35ba..142a2517c1c 100644
--- a/gcc/testsuite/gm2/errors/fail/testparam.mod
+++ b/gcc/testsuite/gm2/errors/fail/testparam.mod
@@ -19,10 +19,15 @@ MODULE testparam ;
 
 FROM FIO IMPORT IsNoError, Close, EOF ;
 
+PROCEDURE init ;
 VAR
    i: INTEGER ;
 BEGIN
    IF EOF(i)
    THEN
    END
+END init ;
+
+BEGIN
+   init
 END testparam.

